<script setup>
import { ref } from "vue";
import { useStore } from "vuex";
import ModalOverlay from "@components/Template/ModalOverlay.vue";

const store = useStore();
const addLevelModal = ref({ visible: false, name: null });

function openModal() {
  addLevelModal.value.visible = true;
}

// Create local Callback Functions
function clickedNewLevel() {
  if (addLevelModal.value.file) {
    const fr = new FileReader();
    fr.addEventListener("load", () => {
      const data = JSON.parse(fr.result);
      if (addLevelModal.value.name) data.name = addLevelModal.value.name;
      store.dispatch("game/createLevel", { level: data }).then(
        () => (addLevelModal.value.visible = false),
        (error) => console.error(error), // on name rejected
      );
    });
    fr.readAsText(addLevelModal.value.file);
  } else if (addLevelModal.value.name) {
    store
      .dispatch("game/createLevel", {
        level: { name: addLevelModal.value.name },
      })
      .then(
        () => (addLevelModal.value.visible = false),
        (error) => console.error(error), // on name rejected
      );
  }
}

function selectedImportLevel(e) {
  if (e.srcElement.files[0].type == "application/json") addLevelModal.value.file = e.srcElement.files[0];
}
</script>
<template>
  <!-- ADD BUTTON -->
  <!-- <button class="button is-link" @click="addLevelModal.visible = true">
    NEW LEVEL
  </button> -->
  <slot name="anchor" :on-click="openModal" />

  <!-- <slot @click="addLevelModal.visible = true"></slot> -->

  <!-- ADD MODAL -->
  <ModalOverlay
    v-if="addLevelModal.visible"
    :modal="addLevelModal"
    :css-classes="[]"
    @close-modal="addLevelModal.visible = false"
  >
    <template #header>Add New Level</template>
    <div>
      <label for="levelname">Create new Level with name</label>
      <input v-model="addLevelModal.name" class="input" type="text" name="levelname" placeholder="name" />
    </div>
    <div class="mt-4">
      <label for="levefile">or import Level file</label>
      <input
        class="button input"
        type="file"
        name="levefile"
        accept="application/json"
        @change="selectedImportLevel($event)"
      />
    </div>
    <template #footer>
      <button class="button is-success" @click="clickedNewLevel($event)">Add new Level</button>
      <button class="button" @click="addLevelModal.visible = false">Cancel</button>
    </template>
  </ModalOverlay>
</template>
